package com.example.remotecontrol;

import android.annotation.SuppressLint;
import android.os.StrictMode;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.util.Log;
import android.view.MotionEvent;
import android.view.View;
import android.widget.Button;
import android.widget.TextView;

import java.io.BufferedReader;
import java.io.DataOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.InetAddress;
import java.net.Socket;
import java.net.UnknownHostException;

public class MainActivity extends AppCompatActivity {

    Button connect, disconnect, danger, leftsig, rightsig, stopsig, forward, left, right, backwards;
    boolean bforward = false, bleft = false,bright = false,bbackwards = false;
    Socket sock = null;
    Thread thread = null;
    TextView textView;

    @SuppressLint("ClickableViewAccessibility")
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        connect = findViewById(R.id.connect);
        disconnect = findViewById(R.id.disconnect);
        danger = findViewById(R.id.danger);
        leftsig = findViewById(R.id.leftsig);
        rightsig = findViewById(R.id.rightsig);
        stopsig = findViewById(R.id.stopsig);
        forward = findViewById(R.id.forward);
        left = findViewById(R.id.leftmove);
        right = findViewById(R.id.rightmove);
        backwards = findViewById(R.id.backward);
        textView = findViewById(R.id.info);

        forward.setOnTouchListener(new View.OnTouchListener() {
            @Override
            public boolean onTouch(View v, MotionEvent event) {
                if(event.getAction() == MotionEvent.ACTION_DOWN){
                    Log.d("ontouch","down");
                    bforward = true;
                    return true;
                } else if(event.getAction() == MotionEvent.ACTION_UP) {
                    bforward = false;
                    Log.d("ontouch","up");
                }
                return false;
            }
        });

        backwards.setOnTouchListener(new View.OnTouchListener() {
            @Override
            public boolean onTouch(View v, MotionEvent event) {
                if(event.getAction() == MotionEvent.ACTION_DOWN){
                    bbackwards = true;
                    return true;
                } else if(event.getAction() == MotionEvent.ACTION_UP) {
                    bbackwards = false;
                }
                return false;
            }
        });

        left.setOnTouchListener(new View.OnTouchListener() {
            @Override
            public boolean onTouch(View v, MotionEvent event) {
                if(event.getAction() == MotionEvent.ACTION_DOWN){
                    bleft = true;
                    return true;
                } else if(event.getAction() == MotionEvent.ACTION_UP) {
                    bleft = false;
                }
                return false;
            }
        });

        right.setOnTouchListener(new View.OnTouchListener() {
            @Override
            public boolean onTouch(View v, MotionEvent event) {
                if(event.getAction() == MotionEvent.ACTION_DOWN){
                    bright = true;
                    return true;
                } else if(event.getAction() == MotionEvent.ACTION_UP) {
                    bright = false;
                }
                return false;
            }
        });


        connect.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if (sock == null) {
                    try {
                        textView.setText("Before sock");
                        enableStrictMode();
                        sock = new Socket(InetAddress.getByName("192.168.0.1"),9876);
                        thread = new Thread(new Runnable() {
                            @Override
                            public void run() {
                                while (true) {
                                    //Log.d("THREAD","TEST");
                                    if (sock == null)
                                        break;
                                    if (!bforward && !bbackwards) {
                                        String test = "0\r";
                                        if (sock != null) {
                                            DataOutputStream outToServer = null;
                                            try {
                                                outToServer = new DataOutputStream(sock.getOutputStream());
                                                outToServer.writeBytes(test);
                                            } catch (IOException e) {
                                                e.printStackTrace();
                                            }
                                        } else {
                                            break;
                                        }
                                        try {
                                            Thread.sleep(100);
                                            continue;
                                        } catch (InterruptedException e) {
                                            e.printStackTrace();
                                        }
                                    }
                                    if(bleft && bforward) {
                                        String test = "8\r";
                                        if (sock != null) {
                                            DataOutputStream outToServer = null;
                                            try {
                                                outToServer = new DataOutputStream(sock.getOutputStream());
                                                outToServer.writeBytes(test);
                                            } catch (IOException e) {
                                                e.printStackTrace();
                                            }
                                        } else {
                                            break;
                                        }
                                        try {
                                            Thread.sleep(100);
                                        } catch (InterruptedException e) {
                                            e.printStackTrace();
                                        }
                                    } else if (bright && bforward) {
                                        String test = "9\r";
                                        if (sock != null) {
                                            DataOutputStream outToServer = null;
                                            try {
                                                outToServer = new DataOutputStream(sock.getOutputStream());
                                                outToServer.writeBytes(test);
                                            } catch (IOException e) {
                                                e.printStackTrace();
                                            }
                                        } else {
                                            break;
                                        }
                                        try {
                                            Thread.sleep(100);
                                        } catch (InterruptedException e) {
                                            e.printStackTrace();
                                        }
                                    }else if(bforward){
                                        String test = "3\r";
                                        if (sock != null) {
                                            DataOutputStream outToServer = null;
                                            try {
                                                outToServer = new DataOutputStream(sock.getOutputStream());
                                                outToServer.writeBytes(test);
                                            } catch (IOException e) {
                                                e.printStackTrace();
                                            }
                                        } else {
                                            break;
                                        }
                                        try {
                                            Thread.sleep(100);
                                        } catch (InterruptedException e) {
                                            e.printStackTrace();
                                        }
                                    }

                                    if(bleft && bbackwards) {
                                        String test = "1\r";
                                        if (sock != null) {
                                            DataOutputStream outToServer = null;
                                            try {
                                                outToServer = new DataOutputStream(sock.getOutputStream());
                                                outToServer.writeBytes(test);
                                            } catch (IOException e) {
                                                e.printStackTrace();
                                            }
                                        } else {
                                            break;
                                        }
                                        try {
                                            Thread.sleep(100);
                                        } catch (InterruptedException e) {
                                            e.printStackTrace();
                                        }
                                    } else if (bright && bbackwards) {
                                        String test = "4\r";
                                        if (sock != null) {
                                            DataOutputStream outToServer = null;
                                            try {
                                                outToServer = new DataOutputStream(sock.getOutputStream());
                                                outToServer.writeBytes(test);
                                            } catch (IOException e) {
                                                e.printStackTrace();
                                            }
                                        } else {
                                            break;
                                        }
                                        try {
                                            Thread.sleep(100);
                                        } catch (InterruptedException e) {
                                            e.printStackTrace();
                                        }
                                    }else if(bbackwards){
                                        String test = "6\r";
                                        if (sock != null) {
                                            DataOutputStream outToServer = null;
                                            try {
                                                outToServer = new DataOutputStream(sock.getOutputStream());
                                                outToServer.writeBytes(test);
                                            } catch (IOException e) {
                                                e.printStackTrace();
                                            }
                                        } else {
                                            break;
                                        }
                                        try {
                                            Thread.sleep(100);
                                        } catch (InterruptedException e) {
                                            e.printStackTrace();
                                        }
                                    }
                                }
                            }
                        });
                        thread.start();
                        if (sock != null)
                            Log.d("CONNECT","WORKED");
                        else
                            Log.d("CONNECT", "DIDNT WORK");
                        textView.setText("You are connected");
                    } catch (UnknownHostException e) {
                        e.printStackTrace();
                    } catch (IOException e) {
                        e.printStackTrace();
                    }
                }
            }
        });

        disconnect.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if (sock == null)
                    Log.d("DISCONNECT", "SOCK IS NULL");
                if (sock != null) {
                    try {
                        sock.close();
                        sock = null;
                        thread.interrupt();
                        thread = null;
                        textView.setText("You are not connected");
                    } catch (IOException e) {
                        Log.d("DISCONNECT","DID NOT WORK");
                        e.printStackTrace();
                    }
                }
            }
        });

        danger.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if (sock != null) {
                    String test = "h\r";
                    try {
                        DataOutputStream outToServer = new DataOutputStream(sock.getOutputStream());
                        outToServer.writeBytes(test);
                    } catch (IOException e) {
                        e.printStackTrace();
                    }
                }
            }
        });

        leftsig.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if (sock != null) {
                    String test = "r\r";
                    try {
                        DataOutputStream outToServer = new DataOutputStream(sock.getOutputStream());
                        outToServer.writeBytes(test);
                    } catch (IOException e) {
                        e.printStackTrace();
                    }
                }
            }
        });

        rightsig.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if (sock != null) {
                    String test = "t\r";
                    try {
                        DataOutputStream outToServer = new DataOutputStream(sock.getOutputStream());
                        outToServer.writeBytes(test);
                    } catch (IOException e) {
                        e.printStackTrace();
                    }
                }
            }
        });

        stopsig.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if (sock != null) {
                    String test = "y\r";
                    try {
                        DataOutputStream outToServer = new DataOutputStream(sock.getOutputStream());
                        outToServer.writeBytes(test);
                    } catch (IOException e) {
                        e.printStackTrace();
                    }
                }
            }
        });

    }

    public void enableStrictMode()
    {
        StrictMode.ThreadPolicy policy = new StrictMode.ThreadPolicy.Builder().permitAll().build();

        StrictMode.setThreadPolicy(policy);
    }

}
